#!/bin/bash
# {{ ansible_managed }}
#
# Show versions of oersi modules
#

ETL_COMMIT_SHA=$(grep "COMMIT_SHA=" {{ oerindex_etl_downloaddir }}/build.info | cut -d'=' -f2)
ETL_BUILDNUMBER=$(grep "BUILDNUMBER=" {{ oerindex_etl_downloaddir }}/build.info | cut -d'=' -f2)
ETL_VERSIONS=$(cat {{ oerindex_etl_downloaddir }}/build.info | jq -sR "[split(\"\n\")[:-1][], \"SOURCE=https://gitlab.com/oersi/oersi-etl/-/tree/${ETL_COMMIT_SHA}\", \"BUILD-JOB=https://gitlab.com/oersi/oersi-etl/-/jobs/${ETL_BUILDNUMBER}\" | split(\"=\") | {(.[0]): .[1]}] | add")

IMPORTSCRIPTS_COMMIT_SHA=$(grep "COMMIT_SHA=" {{ oerindex_import_scripts_dir }}/build.info | cut -d'=' -f2)
IMPORTSCRIPTS_BUILDNUMBER=$(grep "BUILDNUMBER=" {{ oerindex_import_scripts_dir }}/build.info | cut -d'=' -f2)
IMPORTSCRIPTS_VERSIONS=$(cat {{ oerindex_import_scripts_dir }}/build.info | jq -sR "[split(\"\n\")[:-1][], \"SOURCE=https://gitlab.com/oersi/oersi-import-scripts/-/tree/${IMPORTSCRIPTS_COMMIT_SHA}\", \"BUILD-JOB=https://gitlab.com/oersi/oersi-import-scripts/-/jobs/${IMPORTSCRIPTS_BUILDNUMBER}\" | split(\"=\") | {(.[0]): .[1]}] | add")

BACKEND_COMMIT_SHA=$(grep "COMMIT_SHA=" {{ tomcat_home }}/webapps/oersi/WEB-INF/classes/build.info | cut -d'=' -f2)
BACKEND_BUILDNUMBER=$(grep "BUILDNUMBER=" {{ tomcat_home }}/webapps/oersi/WEB-INF/classes/build.info | cut -d'=' -f2)
BACKEND_VERSIONS=$(cat {{ tomcat_home }}/webapps/oersi/WEB-INF/classes/build.info | jq -sR "[split(\"\n\")[:-1][], \"SOURCE=https://gitlab.com/oersi/oersi-backend/-/tree/${BACKEND_COMMIT_SHA}\", \"BUILD-JOB=https://gitlab.com/oersi/oersi-backend/-/jobs/${BACKEND_BUILDNUMBER}\" | split(\"=\") | {(.[0]): .[1]}] | add")

if [ -f {{ oerindex_schemas_instdir }}/build.info ]; then
  SCHEMAS_COMMIT_SHA=$(grep "COMMIT_SHA=" {{ oerindex_schemas_instdir }}/build.info | cut -d'=' -f2)
  SCHEMAS_BUILDNUMBER=$(grep "BUILDNUMBER=" {{ oerindex_schemas_instdir }}/build.info | cut -d'=' -f2)
  SCHEMAS_REPO_URL=$(grep "REPO_URL=" {{ oerindex_schemas_instdir }}/build.info | cut -d'=' -f2)
  SCHEMAS_VERSIONS=$(grep -v "^REPO_URL=" {{ oerindex_schemas_instdir }}/build.info | jq -sR "[split(\"\n\")[:-1][], \"SOURCE=${SCHEMAS_REPO_URL}/-/tree/${SCHEMAS_COMMIT_SHA}\", \"BUILD-JOB=${SCHEMAS_REPO_URL}/-/jobs/${SCHEMAS_BUILDNUMBER}\" | split(\"=\") | {(.[0]): .[1]}] | add")
else
  SCHEMAS_VERSIONS="{}"
fi

FRONTEND_COMMIT_SHA=$(grep "COMMIT_SHA=" {{ oerindex_frontend_instdir }}/build.info | cut -d'=' -f2)
FRONTEND_BUILDNUMBER=$(grep "BUILDNUMBER=" {{ oerindex_frontend_instdir }}/build.info | cut -d'=' -f2)
FRONTEND_VERSIONS=$(cat {{ oerindex_frontend_instdir }}/build.info | jq -sR "[split(\"\n\")[:-1][], \"SOURCE=https://gitlab.com/oersi/oersi-frontend/-/tree/${FRONTEND_COMMIT_SHA}\", \"BUILD-JOB=https://gitlab.com/oersi/oersi-frontend/-/jobs/${FRONTEND_BUILDNUMBER}\" | split(\"=\") | {(.[0]): .[1]}] | add")

jq -n "{\"ETL\": $ETL_VERSIONS, \"Import Scripts\": $IMPORTSCRIPTS_VERSIONS, \"Backend\": $BACKEND_VERSIONS, \"Schemas\": $SCHEMAS_VERSIONS, \"Frontend\": $FRONTEND_VERSIONS}"
